package com.toast.java.logncrash.log4j2.sample;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.apache.logging.log4j.ThreadContext;
import org.junit.Test;

public class LogNCrashLog4j2Sample {
	private static Logger log4j2Logger = LogManager.getLogger(LogNCrashLog4j2Sample.class);
	private static org.slf4j.Logger slf4jLogger = org.slf4j.LoggerFactory.getLogger(LogNCrashLog4j2Sample.class);

	@Test
	public void testLog4J2(){
		log4j2Logger.debug("LogNCrash Log4J2 Test");

		// CustomField Test
		// Accept
		ThreadContext.put("aaa", "custom log test");
		// Reject, reserved field name
		ThreadContext.put("logSource", "can't send");
		// Accept
		ThreadContext.put("a012345678901234567890123456789012345678901234567890123456789", "very long custom field");
		// Reject, too long
		ThreadContext.put("a0123456789012345678901234567890123456789012345678901234567890123456789",
				"very very long custom field");

		try {
			Object a = null;
			a.equals(null);
		} catch (Exception e) {
			// Accept
			log4j2Logger.fatal("null exception", e);
			slf4jLogger.error(e.toString(), e);
		}

		ThreadContext.remove("aaa");
		ThreadContext.remove("logSource");

		try {
			@SuppressWarnings("unused")
			int a = 10 / 0;
		} catch (Exception e) {
			// Reject, no message
			log4j2Logger.fatal("", e);
			// Accept
			log4j2Logger.fatal(e.toString(), e);
		}

		slf4jLogger.debug("LogNCrash Log4J2 SLF4J Test");
	}
}
